Backend: Open-Source Fixedpoint Model-Checker version 2014 
Protocol: ISO_twopass_symm
Types:
[(Purpose,["purposeText2"]),(Agent False False,["A","B","s"]),(Number,["RA","RB","Text1","Text2","Text3"]),(Function,["pk"])]
section rules:
step rule_0:
iknows(crypt(K,M));
iknows(inv(K))

=>
iknows(M)

step rule_1:
iknows(crypt(inv(K),M));
iknows(K)

=>
iknows(M)

step rule_2:
iknows(scrypt(K,M));
iknows(K)

=>
iknows(M)

step rule_3:
iknows(pair(M1,M2))

=>
iknows(M1);
iknows(M2)

step rule_4:
secret(M,Agent (honest a));
iknows(M)

=>
attack(pair(secrecy,M))

step rule_5:
request(A,B,Purpose (purposeRB),M,(SID sid))
 | B/=Agent (dishonest i);
M/=Nonce (absRB(pair(B,A)))
=>
attack(pair(authentication,pair(A,pair(B,M))))

step rule_6:
request(A,B,Purpose (purposeRA),M,(SID sid))
 | B/=Agent (dishonest i);
M/=Nonce (absRA(pair(B,A)))
=>
attack(pair(authentication,pair(A,pair(B,M))))

step rule_7:
request(A,B,Purpose (purposeText2),M,(SID sid))
 | B/=Agent (dishonest i);
M/=Nonce (absText2(pair(B,A)))
=>
attack(pair(authentication,pair(A,pair(B,M))))

step rule_8:
State (rB,[Agent (B),Step 0,pk(Agent (honest a)),(SID sid)])

=>
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (absRB(Agent (B))),(SID sid)]);
iknows(Nonce (absRB(Agent (B))))

step rule_9:
State (rA,[Agent (A),Step 0,inv(pk(Agent (A))),pk(Agent (A)),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),Agent (B),(SID sid)]);
iknows(Nonce (RB))

=>
witness(Agent (A),Agent (B),Purpose (pBAText2),Nonce (absText2(pair(Agent (A),Agent (B)))));
State (rA,[Agent (A),Step 1,inv(pk(Agent (A))),pk(Agent (A)),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),Agent (B),Nonce (RB),Nonce (absRA(pair(Agent (A),Agent (B)))),Nonce (absText2(pair(Agent (A),Agent (B)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (absRA(pair(Agent (A),Agent (B)))),pair(Nonce (RB),pair(Agent (B),Nonce (absText2(pair(Agent (A),Agent (B))))))))),(SID sid)]);
iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (absRA(pair(Agent (A),Agent (B)))),pair(Nonce (RB),pair(Agent (B),Nonce (absText2(pair(Agent (A),Agent (B))))))))))

step rule_10:
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (RB),(SID sid)]);
iknows(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))));
iknows(crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))))

=>
request(Agent (B),Agent (A),Purpose (pBAText2),Nonce (Text2),(SID sid));
State (rB,[Agent (B),Step 2,pk(Agent (honest a)),Nonce (RB),Nonce (Text2),Nonce (RA),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))),pk(Agent (A)),Agent (A),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2)))))),(SID sid)])

step rule_11:
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (RB),(SID sid)]);
iknows(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))));
iknows(inv(pk(Agent (A))));
iknows(Nonce (RA));
iknows(Nonce (RB));
iknows(Agent (B));
iknows(Nonce (Text2))

=>
request(Agent (B),Agent (A),Purpose (pBAText2),Nonce (Text2),(SID sid));
State (rB,[Agent (B),Step 2,pk(Agent (honest a)),Nonce (RB),Nonce (Text2),Nonce (RA),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))),pk(Agent (A)),Agent (A),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2)))))),(SID sid)])

step rule_12:
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (RB),(SID sid)]);
iknows(inv(pk(Agent (honest a))));
iknows(Agent (A));
iknows(pk(Agent (A)));
iknows(crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))))

=>
request(Agent (B),Agent (A),Purpose (pBAText2),Nonce (Text2),(SID sid));
State (rB,[Agent (B),Step 2,pk(Agent (honest a)),Nonce (RB),Nonce (Text2),Nonce (RA),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))),pk(Agent (A)),Agent (A),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2)))))),(SID sid)])

step rule_13:
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (RB),(SID sid)]);
iknows(inv(pk(Agent (honest a))));
iknows(Agent (A));
iknows(pk(Agent (A)));
iknows(inv(pk(Agent (A))));
iknows(Nonce (RA));
iknows(Nonce (RB));
iknows(Agent (B));
iknows(Nonce (Text2))

=>
request(Agent (B),Agent (A),Purpose (pBAText2),Nonce (Text2),(SID sid));
State (rB,[Agent (B),Step 2,pk(Agent (honest a)),Nonce (RB),Nonce (Text2),Nonce (RA),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))),pk(Agent (A)),Agent (A),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2)))))),(SID sid)])

step rule_14:
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (RB),(SID sid)]);
iknows(inv(pk(Agent (honest a))));
iknows(Agent (A));
iknows(crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))))

=>
request(Agent (B),Agent (A),Purpose (pBAText2),Nonce (Text2),(SID sid));
State (rB,[Agent (B),Step 2,pk(Agent (honest a)),Nonce (RB),Nonce (Text2),Nonce (RA),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))),pk(Agent (A)),Agent (A),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2)))))),(SID sid)])

step rule_15:
State (rB,[Agent (B),Step 1,pk(Agent (honest a)),Nonce (RB),(SID sid)]);
iknows(inv(pk(Agent (honest a))));
iknows(Agent (A));
iknows(inv(pk(Agent (A))));
iknows(Nonce (RA));
iknows(Nonce (RB));
iknows(Agent (B));
iknows(Nonce (Text2))

=>
request(Agent (B),Agent (A),Purpose (pBAText2),Nonce (Text2),(SID sid));
State (rB,[Agent (B),Step 2,pk(Agent (honest a)),Nonce (RB),Nonce (Text2),Nonce (RA),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2))))),pk(Agent (A)),Agent (A),crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (A),pk(Agent (A)))),crypt(inv(pk(Agent (A))),pair(Nonce (RA),pair(Nonce (RB),pair(Agent (B),Nonce (Text2)))))),(SID sid)])


section initial state:
init_0: iknows(Nonce (ni));
init_1: iknows(Agent (dishonest i));
init_2: State (rA,[Agent (honest a),Step 0,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),(SID sid)]);
init_3: State (rA,[Agent (honest a),Step 0,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),(SID sid)]);
init_4: iknows(Step 0);
init_5: iknows(inv(pk(Agent (dishonest i))));
init_6: iknows(pk(Agent (dishonest i)));
init_7: iknows(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))));
init_8: iknows((SID sid));
init_9: iknows(Agent (honest a));
init_10: State (rB,[Agent (honest a),Step 0,pk(Agent (honest a)),(SID sid)]);
init_11: iknows(pk(Agent (honest a)));

section fixedpoint:
fp_0: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_1: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_2: iknows(pair(Agent (dishonest i),pk(Agent (dishonest i))));
fp_3: State (rB,[Agent (honest a),Step 1,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),(SID sid)]);
fp_4: witness(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))));
fp_5: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),Nonce (ni),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_6: witness(Agent (honest a),Agent (honest a),Purpose (pBAText2),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))));
fp_7: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),Nonce (ni),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_8: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))));
fp_9: iknows(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))));
fp_10: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))));
fp_11: iknows(Nonce (absRB(Agent (honest a))));
fp_12: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_13: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_14: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_15: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_16: iknows(pair(Agent (dishonest i),pk(Agent (dishonest i))));
fp_17: iknows(pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))));
fp_18: iknows(pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_19: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_20: iknows(pair(Agent (honest a),pk(Agent (honest a))));
fp_21: iknows(pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))));
fp_22: iknows(pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_23: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_24: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_25: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_26: request(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (absRB(Agent (honest a))),(SID sid));
fp_27: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a)))))))),(SID sid)]);
fp_28: request(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (ni),(SID sid));
fp_29: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (ni),Nonce (absRB(Agent (honest a))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni)))))),(SID sid)]);
fp_30: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),Nonce (ni),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a)))))))),(SID sid)]);
fp_31: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (ni),Nonce (ni),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni)))))),(SID sid)]);
fp_32: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))));
fp_33: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))));
fp_34: iknows(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))));
fp_35: iknows(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))));
fp_36: iknows(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))));
fp_37: iknows(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))));
fp_38: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_39: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_40: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_41: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_42: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_43: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_44: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_45: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_46: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_47: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_48: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_49: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_50: iknows(pair(Agent (dishonest i),pk(Agent (dishonest i))));
fp_51: iknows(pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))));
fp_52: iknows(pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_53: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_54: iknows(pair(Agent (honest a),pk(Agent (honest a))));
fp_55: iknows(pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))));
fp_56: iknows(pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_57: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_58: iknows(pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_59: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_60: iknows(pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_61: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_62: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_63: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_64: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_65: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (dishonest i),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_66: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_67: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_68: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_69: State (rA,[Agent (honest a),Step 1,inv(pk(Agent (honest a))),pk(Agent (honest a)),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_70: request(Agent (honest a),Agent (honest a),Purpose (pBAText2),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),(SID sid));
fp_71: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (honest a)),Agent (honest a),crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_72: request(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),(SID sid));
fp_73: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_74: request(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),(SID sid));
fp_75: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_76: request(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),(SID sid));
fp_77: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_78: request(Agent (honest a),Agent (dishonest i),Purpose (pBAText2),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),(SID sid));
fp_79: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_80: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a)))))))),(SID sid)]);
fp_81: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (ni),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni)))))),(SID sid)]);
fp_82: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_83: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_84: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_85: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_86: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a)))))))),(SID sid)]);
fp_87: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (ni),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni)))))),(SID sid)]);
fp_88: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_89: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_90: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_91: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_92: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a)))))))),(SID sid)]);
fp_93: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (ni),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni)))))),(SID sid)]);
fp_94: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_95: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_96: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_97: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_98: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRB(Agent (honest a)))))))),(SID sid)]);
fp_99: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (ni),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (ni)))))),(SID sid)]);
fp_100: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRB(Agent (honest a))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_101: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (absRB(Agent (honest a))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_102: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (absRB(Agent (honest a))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_103: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (absRB(Agent (honest a))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (absRB(Agent (honest a))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_104: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),Nonce (ni),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_105: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),Nonce (ni),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (dishonest i))))))))),(SID sid)]);
fp_106: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),Nonce (ni),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_107: State (rB,[Agent (honest a),Step 2,pk(Agent (honest a)),Nonce (absRB(Agent (honest a))),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),Nonce (ni),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a)))))))),pk(Agent (dishonest i)),Agent (dishonest i),crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),pair(crypt(inv(pk(Agent (honest a))),pair(Agent (dishonest i),pk(Agent (dishonest i)))),crypt(inv(pk(Agent (dishonest i))),pair(Nonce (ni),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absRA(pair(Agent (honest a),Agent (honest a))))))))),(SID sid)]);
fp_108: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))));
fp_109: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))));
fp_110: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))));
fp_111: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))))));
fp_112: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))));
fp_113: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))));
fp_114: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))));
fp_115: iknows(crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))))));
fp_116: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_117: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_118: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_119: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_120: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_121: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))))));
fp_122: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_123: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_124: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_125: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_126: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_127: iknows(pair(crypt(inv(pk(Agent (honest a))),pair(Agent (honest a),pk(Agent (honest a)))),crypt(inv(pk(Agent (honest a))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))))));
fp_128: iknows(pair(Agent (dishonest i),pk(Agent (dishonest i))));
fp_129: iknows(pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))));
fp_130: iknows(pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_131: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (ni),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_132: iknows(pair(Agent (honest a),pk(Agent (honest a))));
fp_133: iknows(pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))));
fp_134: iknows(pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_135: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (ni),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_136: iknows(pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_137: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_138: iknows(pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_139: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRB(Agent (honest a))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_140: iknows(pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_141: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_142: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_143: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_144: iknows(pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_145: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_146: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))))));
fp_147: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (dishonest i),Nonce (absText2(pair(Agent (honest a),Agent (dishonest i))))))));
fp_148: iknows(pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_149: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_150: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_151: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (dishonest i)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_152: iknows(pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_153: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absText2(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));
fp_154: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a)))))));
fp_155: iknows(pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Nonce (absRA(pair(Agent (honest a),Agent (honest a)))),pair(Agent (honest a),Nonce (absText2(pair(Agent (honest a),Agent (honest a))))))));

section abstraction:
RB->Nonce (absRB(B));
RA->Nonce (absRA(pair(A,B)));
Text2->Nonce (absText2(pair(A,B)))

